/* $Id: strik.java,v 1.9 2012/02/04 23:30:38 mit Exp $ */
/* strik.java v0.0 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class strik extends Applet 
    implements Runnable, ActionListener, AdjustmentListener
{
    private Panel PS;
    private Panel PE;
    private Button btGo;
    private Button btStop;
    private Button btDisp;
    private Button btP;
    private Button btM;
    private Scrollbar scrSP;
    private Label lbSP;
    private Thread th;

    static int LEN = 64;
    static int PAR = 40;
    static int HZ = 1;
    static int FLM = 64;
    static double DT = 2.0*Math.PI/FLM; // 0.098175(64) 0.069813(90)

    boolean Runsw;
    int W;
    int H;
    int H2;
    int DOT = 4;
    int SFT = DOT/2;
    int LOOP;
    int DISP;
    double SP = 8.0/LEN;
    double DD;
    double DH;
    double VOL = 2.0;

    Graphics gi;
    Image ig;
    DecimalFormat df1;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

	PS = new Panel();
        PS.setLayout(new GridLayout(2,3,0,0));

        btGo = new Button("GO");
        PS.add(btGo);
        btGo.addActionListener(this);

        btStop = new Button("Stop");
        PS.add(btStop);
        btStop.addActionListener(this);

	PS.add(new Label(""));

	scrSP = new Scrollbar(Scrollbar.HORIZONTAL,LEN/8,1,1,LEN);
        PS.add(scrSP);
        scrSP.addAdjustmentListener(this);

	lbSP = new Label(": Striking Point 1/___");
	PS.add(lbSP);

        btDisp = new Button("Disp. __");
        PS.add(btDisp);
        btDisp.addActionListener(this);

	add(PS, "South");

	PE = new Panel();
        PE.setLayout(new GridLayout(4,1,0,0));

	PE.add(new Label(""));
	PE.add(new Label(""));

        btP = new Button("+");
        PE.add(btP);
        btP.addActionListener(this);

        btM = new Button("-");
        PE.add(btM);
        btM.addActionListener(this);

	add(PE, "East");
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	DD = W/(double)(LEN+1); // +1
	DH = H*VOL;

	ig = createImage(W, H);
	gi = ig.getGraphics();

	set_label();
	write_disp();

	if (th == null) {
            th = new Thread(this);
            th.start();
        }
    }
    public Dimension getCanvasD() {
        Dimension ds = PS.getSize();
	Dimension de = PE.getSize();
        Dimension da = getSize();
        int cw = da.width-de.width;
        int ch = da.height-ds.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void run() {
	while(!Runsw) {
            try {
		LOOP++;
		if (LOOP > Integer.MAX_VALUE)
		    LOOP = 0;

		repaint();
                th.sleep(100);
            } 
            catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
    public void stop() {
        if (th != null) {
            th = null;

	    LOOP = 0;
	}
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btStop)
	    Runsw = true;
        else if (e.getSource() == btGo) {
            Runsw = false;
            th = null;
            start();
        }
	else if (e.getSource() == btDisp)
	    set_disp();

	else if (e.getSource() == btP)
	    set_volume(true);
	else if (e.getSource() == btM)
	    set_volume(false);
    }
    public void set_disp() {
	DISP++;
	if (DISP > 5)
	    DISP = 0;

	write_disp();
    }
    public void set_volume(boolean sw) {
	double by = Math.sqrt(2);

	VOL = sw ? VOL*by : VOL/by; 
	DH = H*VOL;
    }
    public void write_disp() {
	btDisp.setLabel("Disp. "+DISP);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == scrSP) {
	    SP = scrSP.getValue()/(double)LEN;
	    set_label();

	    repaint();
	}
    }
    public void set_label() {
	lbSP.setText(": Striking Point 1/"+dform(1/SP));
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        paintI();
        g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
        gi.setColor(Color.black);
        gi.fillRect(0, 0, W, H);

	disp_line(gi);

	int dx;
	double[] val = new double[7];
	for (int i = 0; i <= LEN; i++) { // <=
	    dx = (int)(DD*i+SFT);

	    val = striking(i);

	    if (DISP > 1 & DISP < 4 | DISP == 5 ) {
		gi.setColor(Color.gray);
		gi.fillOval(dx, (int)(H2-DH*val[1]), DOT, DOT);
		gi.fillOval(dx, (int)(H2-DH*val[2]), DOT, DOT);
		gi.fillOval(dx, (int)(H2-DH*val[4]), DOT, DOT);
		gi.fillOval(dx, (int)(H2-DH*val[5]), DOT, DOT);
	    } 
	    if (DISP > 0 & DISP < 5) {
		gi.setColor(Color.lightGray);
		gi.fillOval(dx, (int)(H2-DH*val[3]), DOT, DOT);
		gi.fillOval(dx, (int)(H2-DH*val[6]), DOT, DOT);
	    }
	    if (DISP < 3 ) {
		gi.setColor(Color.green);
		gi.fillOval(dx, (int)(H2-DH*val[0]), DOT, DOT);
	    }
	}
    }
    public double[] striking(int x) {
	double mp, ms, st, te0, te1;
	double[] vs = new double[7];

	for (int i = 1; i < PAR; i++) {
	    mp = i*Math.PI;
	    ms = mp*SP;
	    te0 = i*DT*LOOP*HZ;
	    te1 = i*DT*(LOOP-1)*HZ;

	    st = Math.sin(mp*x/LEN)/(i*i);
	    vs[1] += st*Math.sin(ms+te1);
	    vs[2] += st*Math.sin(ms+te0);
	    vs[4] += st*Math.sin(ms-te1);
	    vs[5] += st*Math.sin(ms-te0);

	    vs[3] += st*Math.sin(ms)*Math.cos(te0);
	    vs[6] += st*Math.sin(ms)*Math.cos(te1);
	}
	vs[0] = vs[6]-vs[3];

	return vs;
    }
    public void disp_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2+SFT, W, H2+SFT);
    }
}